/*
 * Il programma alloca un numero di strutture di tipo struct dato.
 * Il numero di strutture viene fornito da linea di comando.
 *
 * I valori nelle singole strutture contengono dati generati in modo
 * pseudo-casuale, e rappresentano l'iniziale di un nome e di un cognome
 * (es. "F." o "T."), e un valore numerico che rappresenti una età.
 *
 * Dopo l'assegnamento, i valori vengono stampati col formato (esempio):
 *
 * N. W. ha 25 anni
 * R. B. ha 23 anni
 * M. Q. ha 27 anni
 * ...
 *
 * Al termine del programma, viene liberata la memoria precedentemente allocata.
 *
 * Se al programma non viene fornito alcun paramentro, deve terminare
 * senza errori e senza stampare niente.
 * */
#include <stdio.h>
#include <stdlib.h>

struct dato {
    char *nome;
    char *cognome;
    long eta;
};

void assegna_iniziale(char *stringa)
{
    char iniziale;
    iniziale = 'A' + (rand() % 26);
    stringa[0] = iniziale;
    stringa[1] = '.';
}

int main(int argc, char *argv[])
{
    struct dato *vet;
    int i, n;

    n = atoi(argv[1]);

    vet = malloc(n);

    for (i = 0; i <= n; i += 2) {
        assegna_iniziale((vet + i)->nome);
        assegna_iniziale((vet + i)->cognome);
        (vet + i)->eta = 18 + rand() % 10;
    }

    for (i = 0; i < n; i += 1)
        printf("%s %s ha %ld anni\n",
                (vet + i)->nome,
                (vet + i)->cognome,
                (vet + i)->eta
                );

    free(vet);
    for (i = 0; i < n; i += 1) {
        free((vet + i)->nome);
        free((vet + i)->cognome);
        free((void *)(vet + i)->eta);
    }

    return 0;
}
